#ifndef _ACT_MOVEMENT_HPP_
#define _ACT_MOVEMENT_HPP_

#include "structs.h"

class CHAR_DATA;    // to avoid inclusion
class OBJ_DATA;

enum DOOR_SCMD : int {
	SCMD_OPEN = 0,    // 
	SCMD_CLOSE = 1,   // 
	SCMD_UNLOCK = 2,  // 
	SCMD_LOCK = 3,    // 
	SCMD_PICK = 4  // 
};

enum FD_RESULT : int {
	FD_WRONG_DIR = -1,  // -1  
	FD_WRONG_DOOR_NAME = -2,  // -2      
	FD_NO_DOOR_GIVEN_DIR = -3,  // -3     
	FD_DOORNAME_EMPTY = -4, // -4   
	FD_DOORNAME_WRONG = -5   // -5   
};

void do_doorcmd(CHAR_DATA *ch, OBJ_DATA *obj, int door, DOOR_SCMD scmd);
void do_gen_door(CHAR_DATA *ch, char *argument, int cmd, int subcmd);
void do_enter(CHAR_DATA *ch, char *argument, int cmd, int subcmd);
void do_stand(CHAR_DATA *ch, char *argument, int cmd, int subcmd);
void do_sit(CHAR_DATA *ch, char *argument, int cmd, int subcmd);
void do_rest(CHAR_DATA *ch, char *argument, int cmd, int subcmd);
void do_sleep(CHAR_DATA *ch, char *argument, int cmd, int subcmd);
void do_wake(CHAR_DATA *ch, char *argument, int cmd, int subcmd);

int has_boat(CHAR_DATA *ch);
int has_key(CHAR_DATA *ch, obj_vnum key);
bool ok_pick(CHAR_DATA* ch, obj_vnum keynum, OBJ_DATA* obj, int door, int scmd);
int legal_dir(CHAR_DATA *ch, int dir, int need_specials_check, int show_msg);

int skip_hiding(CHAR_DATA *ch, CHAR_DATA *vict);
int skip_sneaking(CHAR_DATA *ch, CHAR_DATA *vict);
int skip_camouflage(CHAR_DATA *ch, CHAR_DATA *vict);

#endif // _ACT_MOVEMENT_HPP_

// vim: ts=4 sw=4 tw=0 noet syntax=cpp :
