#include "create.h"

#include "crafts/im.h"
#include "magic/spells.h"
#include "comm.h"
#include "magic/magic_utils.h"
#include "handler.h"

void do_create(CHAR_DATA *ch, char *argument, int/* cmd*/, int subcmd) {
	char *s;
	int spellnum, itemnum = 0;

	if (IS_NPC(ch))
		return;

	// get: blank, spell name, target name
	argument = one_argument(argument, arg);

	if (!*arg) {
		if (subcmd == SCMD_RECIPE)
			send_to_char("    ?\r\n", ch);
		else
			send_to_char("   ?\r\n", ch);
		return;
	}

	size_t i = strlen(arg);
	if (!strn_cmp(arg, "potion", i) || !strn_cmp(arg, "", i))
		itemnum = SPELL_POTION;
	else if (!strn_cmp(arg, "wand", i) || !strn_cmp(arg, "", i))
		itemnum = SPELL_WAND;
	else if (!strn_cmp(arg, "scroll", i) || !strn_cmp(arg, "", i))
		itemnum = SPELL_SCROLL;
	else if (!strn_cmp(arg, "recipe", i) || !strn_cmp(arg, "", i) ||
		!strn_cmp(arg, "", i)) {
		if (subcmd != SCMD_RECIPE) {
			send_to_char("   .\r\n", ch);
			return;
		}
//		itemnum = SPELL_ITEMS;
		compose_recipe(ch, argument, 0);
		return;
	} else if (!strn_cmp(arg, "runes", i) || !strn_cmp(arg, "", i)) {
		if (subcmd != SCMD_RECIPE) {
			send_to_char("  .\r\n", ch);
			return;
		}
		itemnum = SPELL_RUNES;
	} else {
		if (subcmd == SCMD_RECIPE)
			snprintf(buf, MAX_INPUT_LENGTH, " '%s'   .\r\n", arg);
		else
			snprintf(buf, MAX_INPUT_LENGTH, " '%s'    .\r\n", arg);
		send_to_char(buf, ch);
		return;
	}

	s = strtok(argument, "'*!");
	if (s == NULL) {
		sprintf(buf, "  !\r\n");
		send_to_char(buf, ch);
		return;
	}
	s = strtok(NULL, "'*!");
	if (s == NULL) {
		send_to_char("       : '  *  !\r\n", ch);
		return;
	}

	spellnum = fix_name_and_find_spell_num(s);

	// Unknown spell
	if (spellnum < 1 || spellnum > SPELLS_COUNT) {
		send_to_char("    ?\r\n", ch);
		return;
	}

	// Caster is don't know this recipe
	if (!IS_SET(GET_SPELL_TYPE(ch, spellnum), itemnum) && !IS_IMMORTAL(ch)) {
		send_to_char("       .\r\n", ch);
		return;
	}

	if (subcmd == SCMD_RECIPE) {
		check_recipe_values(ch, spellnum, itemnum, TRUE);
		return;
	}

	if (!check_recipe_values(ch, spellnum, itemnum, FALSE)) {
		send_to_char("     .\r\n", ch);
		return;
	}

	if (!check_recipe_items(ch, spellnum, itemnum, TRUE)) {
		send_to_char("    !\r\n", ch);
		return;
	}
}
