#include "forget.h"

#include "magic/spells_info.h"
#include "handler.h"
#include "crafts/im.h"
#include "screen.h"

inline bool in_mem(char *arg) {
	return (strlen(arg) != 0) &&
		(!strn_cmp("", arg, strlen(arg)) ||
			!strn_cmp("", arg, strlen(arg)) || !strn_cmp("book", arg, strlen(arg)));
}

void do_forget(CHAR_DATA *ch, char *argument, int/* cmd*/, int/* subcmd*/) {
	char *s = 0, *t = 0;
	int spellnum, is_in_mem;

	//    |
	one_argument(argument, arg);

	if (!*arg) {
		send_to_char("   ?\r\n", ch);
		return;
	}

	size_t i = strlen(arg);
	if (!strn_cmp(arg, "recipe", i) || !strn_cmp(arg, "", i) ||
		!strn_cmp(arg, "", i)) {
		forget_recipe(ch, argument, 0);
		return;
	}

	if (!strn_cmp(arg, "", i) || !strn_cmp(arg, "all", i)) {
		char arg2[MAX_INPUT_LENGTH];
		two_arguments(argument, arg, arg2);
		if (in_mem(arg2)) {
			MemQ_flush(ch);
			send_to_char("        .\r\n", ch);
		} else {
			for (i = 1; i <= SPELLS_COUNT; i++) {
				GET_SPELL_MEM(ch, i) = 0;
			}
			sprintf(buf,
					"     %s.\r\n",
					GET_RELIGION(ch) == RELIGION_MONO ? " " : " ");
			send_to_char(buf, ch);
		}
		return;
	}
	// get: blank, spell name, target name
	if (IS_IMMORTAL(ch)) {
		send_to_char(",    skillset?\r\n", ch);
		return;
	}
	s = strtok(argument, "'*!");
	if (s == NULL) {
		send_to_char("    ?\r\n", ch);
		return;
	}
	s = strtok(NULL, "'*!");
	if (s == NULL) {
		send_to_char("       : '  *  !\r\n", ch);
		return;
	}
	spellnum = fix_name_and_find_spell_num(s);
	// Unknown spell
	if (spellnum < 1 || spellnum > SPELLS_COUNT) {
		send_to_char("     ?\r\n", ch);
		return;
	}
	if (!IS_SET(GET_SPELL_TYPE(ch, spellnum), SPELL_KNOW | SPELL_TEMP)) {
		send_to_char("  ,   ...\r\n", ch);
		return;
	}
	t = strtok(NULL, "\0");
	is_in_mem = 0;
	if (t != NULL) {
		one_argument(t, arg);
		is_in_mem = in_mem(arg);
	}
	if (!is_in_mem)
		if (!GET_SPELL_MEM(ch, spellnum)) {
			send_to_char("   - ,   - ...\r\n", ch);
			return;
		} else {
			GET_SPELL_MEM(ch, spellnum)--;
			GET_CASTER(ch) -= spell_info[spellnum].danger;
			sprintf(buf, "   '%s%s%s'  %s.\r\n",
					KICYN, spell_info[spellnum].name,
					KNRM, GET_RELIGION(ch) == RELIGION_MONO ? " " : " ");
			send_to_char(buf, ch);
		}
	else
		MemQ_forget(ch, spellnum);
}
